

mcqGetCompar <-function (object, flist=NULL) {

	if (!is.null(flist)) {
		if (is.vector(flist)) {

		}
		else {
			flist <- c(flist);
		}
	}

	if (class(object) == "mcqProtValue") {
		tab <- object@protval[,c("protein", "msrun","q")]
		tab <- merge (tab, object@proteins, by.x="protein", by.y="row.names")

		#if (is.null(object@metadata@metadata)) {
		if (is.null(flist)) {
			tab <- tapply(tab$q,list(tab$accession,tab$msrun),FUN=sum,na.rm=T)
			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			#tab$regroup <- paste (tab[ , flist], sep="-")
			tab$regroup=tab[,flist[1]]
			if (length(flist)>1){
				for (i in 2:length(flist)){
					tab$regroup = paste(tab$regroup,tab[,flist[i]],sep="-")
				}
			}
			tab <- tapply(tab$q,list(tab$accession,tab$regroup),FUN=mean,na.rm=T)
			return (as.data.frame(tab))
		}
	}
	else if (class(object) == "mcqProtPep") {
		if (is.null(object@peptides$lognorm)) {
			tab <- object@peptides[,c("peptiz", "msrun","logarea")]
			colnames(tab)[colnames(tab) == "logarea"] <- "q"
		}
		else {
			tab <- object@peptides[,c("peptiz", "msrun","lognorm")]
			colnames(tab)[colnames(tab) == "lognorm"] <- "q"
		}
		#tab <- merge (tab, object@proteins, by.x="protein", by.y="row.names")

		if (is.null(flist)) {
			tab <- tapply(tab$q,list(tab$peptiz,tab$msrun),FUN=sum,na.rm=T)
			return (as.data.frame(tab))
		}
		else {
			for (factor in flist) {
				if(factor %in% names(object@metadata@metadata)) {
				}else {
					stop(paste("factor ", factor, " is not described in your metadata\n", "available factors are : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
				}
			}


			object@metadata@metadata$msrun <- rownames(object@metadata@metadata)
			tab <- merge(tab, object@metadata@metadata, by="msrun")

			#tab$regroup <- paste (tab[ , flist], sep="-")
			tab$regroup=tab[,flist[1]]
			if (length(flist)>1){
				for (i in 2:length(flist)){
					tab$regroup = paste(tab$regroup,tab[,flist[i]],sep="-")
				}
			}
			tab$regroup <- as.factor(tab$regroup)
			tab <- tapply(tab$q,list(tab$peptiz,tab$regroup),FUN=sum,na.rm=T)
			return (as.data.frame(tab))

		}
	}
	else if ((class(object) == "mcqPeakcounting") || (class(object) == "mcqSpectralcounting")) {
		## export resultat pour tableur
		ni.deploye=tapply(object@count$count,list(object@count$protein,object@count$msrunfile),FUN=sum)
		anov <- object@resultanov
		colnames(anov) <- paste("pval_", colnames(anov), sep="")
		ni.deploye=merge(ni.deploye,anov,by="row.names")
		rownames(ni.deploye) <- rownames(anov)
		#colnames(ni.deploye)[which(colnames(ni.deploye)=="Row.names")]="Proteine"
		#write.table(ni.deploye,filename,sep="\t",row.names=F,col.names=T)
		ni.deploye$Row.names <- NULL
		return (ni.deploye)
	}
	else if (class(object) == "mcqProtAnova") {
		## export resultat pour tableur
		#dfprotval <- mcqGetDataframe(object)
		#ni.deploye=tapply(dfprotval$q,list(dfprotval$protein,dfprotval$msrunfile),FUN=sum)
		anov <- object@resultanov
		colnames(anov) <- paste("pval_", colnames(anov), sep="")
		anov <- merge(anov, object@proteins, by.x="row.names", by.y="row.names")
	rownames(anov) <-  anov$accession
   anov$accession <- NULL
anov$descr <- NULL
anov$Row.names <- NULL
		return (anov)
	}

	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqGetCompar",sep=""))
	}
}


mcqWriteComparCsv <- function (object, csv, flist=NULL) {
	if (is.null(csv)) {
		stop("Please give an output filename")
	}
	df <-mcqGetCompar(object, flist)
	df <- cbind.data.frame(rownamesbidon = rownames(df), df)
	#colnames(df)[colnames(df)=="rownamesbidon"]=""
	colnames(df)[1]=""
	write.table(df,csv, quote= FALSE,  sep="\t", dec=".",row=F)
}