

mcqGetDataframe <- function (object, comp=F) {
	if (class(object) == "mcqProtValue") {
		#if (is.null(object@metadata@metadata)) {
		if (nrow(object@metadata@metadata)==0) {
			return (object@protval)
		}
		else {
			tprot <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")
			return (tprot)
		}
	}
	else if (class(object) == "mcqProtPep") {
		#if (is.null(object@metadata@metadata)) {
		if (nrow(object@metadata@metadata)==0) {
			return (object@peptides)
		}
		else {
			tpep <- merge(object@peptides, object@metadata@metadata, by.x="msrun", by.y="row.names")
			return (tpep)
		}
	}
	else if (class(object) == "mcqProtAnova") {

		tprotanova <- merge(object@protval, object@metadata@metadata, by.x="msrun", by.y="row.names")
		tprotanova <- merge(tprotanova, object@proteins, by.x="protein", by.y="row.names")
		#if (is.null(object@resultanov)) {
		if (nrow(object@resultanov)==0) {
		}
		else {
			resultannov <- object@resultanov
			#rename resultannov columns (it contains pvalues, not metadata)
			colnames(resultannov) <- paste("pval_",colnames(resultannov), sep="")
			tprotanova <- merge(tprotanova,resultannov, by.x="protein", by.y="row.names")
		}
		return (tprotanova)

	} else if ((class(object) == "mcqPeakcounting") || (class(object) == "mcqSpectralcounting")) {
		tprotanova <- merge(object@count, object@metadata@metadata, by.x="msrun", by.y="row.names")
		#if (is.null(object@resultanov)) {
		if (nrow(object@resultanov)==0) {
		}
		else {
			resultannov <- object@resultanov
			#rename resultannov columns (it contains pvalues, not metadata)
			colnames(resultannov) <- paste("pval_",colnames(resultannov), sep="")
			tprotanova <- merge(tprotanova,resultannov, by.x="protein", by.y="row.names")
			#object@paramlist$df.peak.diff
			if (!is.null(object@paramlist$df.peak.diff)) {
				tprotanova <- merge(tprotanova,object@paramlist$df.peak.diff, by.x="protein", by.y="Protein")
			}
		}
		return (tprotanova)
	} else if ((class(object) == "mcqPeptidePCA") || (class(object) == "mcqProtPCA")) {
	if(comp) {
  #write component table
		return (privGetMcqPCADudiComponent(object))
  }
  else {
		return (privGetMcqPCADudi(object))
}
	} 
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqGetDataframe",sep=""))
	}
}


mcqWriteCsv <- function (object, csv, comp=F) {
	if (is.null(csv)) {
		stop("Please give an output filename")
	}
	write.table(mcqGetDataframe(object,comp),csv, quote= FALSE,  sep="\t", dec=".",row=F)
}