
mcqPlotDistribQlogDiffRef<- function (object, refSample, pdf=NULL) {
	if (class(object) == "mcqProtPep") {
		################ normalisation ze
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("the sample named ",refSample," is not in your mcqProtPep object"))
		}
		nomref=refSample # choisir ici l'échantillon qui servira de référence
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

		ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		## visu des distributions avant normalisation
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf)
		}
		for (i in 1:nbech) {
			if (i !=ref ) {
				hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			}
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}

mcqPlotDistribQlog<- function (object, pdf=NULL) {
	if (class(object) == "mcqProtPep") {
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)


		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697

		## visu des distributions avant normalisation
		#pdf("distributions-intensités-avant-normalisation.pdf")
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf)
		}
		for (i in 1:nbech) {
			#if (i !=ref ) {
			#hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			hist(tab.acp[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")"))
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}


mcqPlotDistribQlogCometDiff<- function (object, refSample, pdf=NULL) {
	if (class(object) == "mcqProtPep") {
		################ normalisation ze
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("the sample named ",refSample," is not in your mcqProtPep object"))
		}
		nomref=refSample # choisir ici l'échantillon qui servira de référence
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

		ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		## visu des distributions avant normalisation
		#pdf("cometes-avant-normalisation.pdf",title="fusées")
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf)
		}
		for (i in 1:nbech) {
			#if (i !=ref ) {
			#hist(diff[,i],nclass=100,main=colnames(tab.acp)[i],xlab=paste("logQ(",colnames(tab.acp)[i],")-logQ(",refSample,")"),xlim=c(-2,2))
			plot(tab.acp[,c(ref,i)])
		}
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}


mcqNormalizeBySampleref<- function (object, refSample) {
	if (class(object) == "mcqProtPep") {
		################ normalisation ze
		if (refSample %in% object@peptides$msrun) {

		}
		else {
			stop(paste("the sample named ",refSample," is not in your mcqProtPep object"))
		}
		nomref=refSample # choisir ici l'échantillon qui servira de référence
		tab.acp<- tapply (object@peptides$logarea, list(object@peptides$peptiz,object@peptides$msrun), FUN=sum)

		#tab.acp => rows = peptiz, cols = msrun, cell = sum of logarea

		ref=which(colnames(tab.acp)==nomref) # ref: numero de la colonne de ref dans tab.acp
		nbech=dim(tab.acp)[2] # 19
		nbpep=dim(tab.acp)[1] # 12697
		matref=matrix(rep(tab.acp[,ref],nbech),ncol=nbech)
		diff=tab.acp-matref

		## normalisation per se
		diffmed=apply(diff,2,median,na.rm=TRUE)
		diffmed=as.data.frame(diffmed)
#diffmed$msrun=rownames(diffmed)
		object@peptides=merge(object@peptides, diffmed, by.x="msrun", by.y="row.names")
		object@peptides$lognorm=object@peptides$logarea-object@peptides$diffmed
		object@peptides$areanorm=10^(object@peptides$lognorm)
		return (object)
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}

mcqPlotNormalizationEffect<- function (object, pdf=NULL) {
	if (class(object) == "mcqProtPep") {
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf)
		}
		if (is.null(object@peptides$lognorm)) {
			stop(paste("your mcqProtPep was not normalized\n", sep=""))
		}
		boxplot(logarea~msrun, data=object@peptides,main="avant normalisation",cex.axis=0.5,las=2)
		boxplot(lognorm~msrun, data=object@peptides,main="après normalisation",cex.axis=0.5,las=2)
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}
