

mcqNewPeakcounting = function(object) {
	if (class(object) == "mcqProtPep") {

		tab<- merge(object@peptides[,c("peptide", "msrun")],object@proteins,by="peptide")
		ni <- as.data.frame(table(list(tab$accession,tab$msrun)))
		colnames(ni)<-c("protein","msrun","count")

		#print(ni)
		#meta <-  object@metadata@metadata
		#meta$msrun <- rownames(object@metadata@metadata)

		#colnames(ni)=c("protein","msrun","count")
		ni=merge(ni,unique(object@peptides[,c("msrun", "msrunfile")]),by="msrun")
		ni=drop.levels(ni)

		mcqCount <- new ("mcqPeakcounting", metadata = object@metadata, count=ni, resultanov= data.frame(), paramlist = list())
		return(mcqCount)
	}
	else {
		if (class(object) != "mcqData") {
			stop("input is not an mcqData or mcqProtPep object")
		}
		else {
			stop("mcqPeakCounting not implemented for mcqData")
		}
	}
	return (NULL)
}
#
#mcqPeakcountingWriteCsv = function (object, filename) {
#	if (class(object) == "mcqPeakcounting") {
## export resultat pour tableur
#		ni.deploye=tapply(object@count$count,list(object@count$protein,object@count$msrunfile),FUN=sum)
#		ni.deploye=merge(ni.deploye,object@resultanov,by="row.names")
#		#colnames(ni.deploye)[which(colnames(ni.deploye)=="Row.names")]="Proteine"
#		write.table(ni.deploye,filename,sep="\t",row.names=F,col.names=T)
#	}
#	else {
#		stop("input is not an mcqPeakcounting object")
#	}
##return (NULL)
#}

mcqPlotPeakcountingPeakPerSamples = function (object, filename,pdf=NULL) {
	if (class(object) == "mcqPeakcounting") {
		privMcqPlotPeakcountPeakPerSamples(object, filename,pdf)
	}
	else {
		stop("input is not an mcqPeakcounting object")
	}
	#return (NULL)
}

mcqPeakcountingAnova = function (object, factorList, kruskal=F) {
	if (class(object) == "mcqPeakcounting") {
		return (privMcqSpectralcountAnova(object, factorList, kruskal))
	}
	else {
		stop("input is not an mcqPeakcounting object")
	}

}


mcqSelectPeakcountingAnovaSignif <- function (object,pvalue, mindiff, factor=NULL) {
	if (class(object) == "mcqPeakcounting") {
		return (privMcqSelectPeakcountAnovaSignif(object,pvalue, mindiff, factor))
	}
	else {
		stop("input is not an mcqPeakcounting object")
	}

}


mcqPlotPeakcountingAnova =  function (object, factor=NULL, pdf=NULL) {
	if (class(object) == "mcqPeakcounting") {
		privMcqPlotPeakcountAnova(object, factor, pdf)
	}
	else {
		stop("input is not an mcqPeakcounting object")
	}

}
