


mcqGetProtlist <- function(object) {
	if (class(object) == "mcqProtAnova") {
		proteinvector <- as.character(object@proteins$descr)
		names(proteinvector) <- as.character(object@proteins$accession)
		
		newObject <- new ("mcqProtList", proteins = proteinvector)
		return (newObject)
	}
	else if ((class(object) == "mcqPeakcounting") || (class(object) == "mcqSpectralcounting")) {
		proteinvector <- unique(as.character(object@count$protein))
		names(proteinvector) <- proteinvector
		
		newObject <- new ("mcqProtList", proteins = proteinvector)
		return (newObject)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqGetProtlist",sep=""))
	}
}

mcqSelectProtlist <- function(object, protlist) {
	if (class(object) == "mcqProtValue") {
		#metadata = object@metadata	, proteins = prot.prot, protval = tprot, samples = tsamples
		
		object@proteins <- object@proteins[object@proteins$accession %in% names(protlist@proteins) ,]
		object@proteins <- drop.levels(object@proteins)
		
		object@protval <- object@protval[object@protval$protein %in% rownames(object@proteins) ,]
		object@protval <- drop.levels(object@protval)
		
		
		object@samples$bidonnage <- rownames(object@samples)
		object@samples <- object@samples[unique(object@protval$msrun) ,]
		object@samples$bidonnage <- NULL
		object@samples <- drop.levels(object@samples)
		
		
		object@metadata@metadata$bidonnage <- rownames(object@metadata@metadata)
		object@metadata@metadata <- object@metadata@metadata[rownames(object@samples) ,]
		object@metadata@metadata$bidonnage <- NULL
		object@metadata@metadata <- drop.levels(object@metadata@metadata)
		
		
		return (object)
	}
	else {
		stop(paste("the class \"", class(object),"\" is not taken into account by mcqSelectProtlist",sep=""))
	}
}