

read.mcqSpectralcounting = function(comparspectraFile) {
	scounting = read.table(comparspectraFile,header=T,sep="\t",check.names=FALSE, dec=".", allowEscapes = FALSE, quote="")
	scounting$protein=as.factor(substr(scounting[,"Top Protein Description"],1,regexpr(" ",scounting[,"Top Protein Description"])-1))
	samples=colnames(scounting)[7:length(scounting)-1]
	scounting=melt(scounting, id.vars = "protein", measure.vars = samples)
	colnames(scounting)=c("protein","msrunfile","count")
	#scounting=merge(scounting,unique(protPep@peptides[,c("msrun", "msrunfile")]),by="msrunfile")
	mcqCount <- new ("mcqSpectralcounting", count=scounting, resultanov= data.frame())
	return(mcqCount)
}


mcqPlotSpectralcountingPeakPerSamples = function (object, filename,pdf=NULL) {
	if (class(object) == "mcqSpectralcounting") {
		privMcqPlotPeakcountPeakPerSamples(object, filename,pdf)
	}
	else {
		stop("input is not an mcqSpectralcounting object")
	}
	#return (NULL)
}

mcqSpectralcountingAnova =  function (object, factorList, kruskal=F)  {
# methode identique mcqPeakcountingAnova !
	if (class(object) == "mcqSpectralcounting") {
		return (privMcqSpectralcountAnova(object, factorList, kruskal))
	}
	else {
		stop("input is not an mcqSpectralcounting object")
	}
}


mcqSelectSpectralcountingAnovaSignif <- function (object,pvalue, mindiff, factor=NULL) {
	if (class(object) == "mcqSpectralcounting") {
		return (privMcqSelectPeakcountAnovaSignif(object,pvalue, mindiff, factor))
	}
	else {
		stop("input is not an mcqSpectralcounting object")
	}
}


mcqPlotSpectralcountingAnova <-  function (object, factor=NULL, pdf=NULL) {
	if (class(object) == "mcqSpectralcounting") {
		privMcqPlotPeakcountAnova(object, factor, pdf)
	}
	else {
		stop("input is not an mcqSpectralcounting object")
	}

}


