

setMethod('summary', "mcqProtPep",
		function(object, ...) {
			#nb de protéines (length(levels(protein)), nb de peptiz (length(levels(peptiz))), nb de peptides 	(length(levels(peptiz))),
			######## nb de samples (length(levels(msrun)))
			#		print (summary (object@proteins))

			cat (paste("number of proteins : ", length(unique(object@proteins$protein)),"\n", sep=""));
			cat (paste("number of XICs : ", length(object@peptides$peptiz),"\n", sep=""));
			cat (paste("number of peptiz : ", length(unique(object@peptides$peptiz)),"\n", sep=""));
			cat (paste("number of peptides : ", length(unique(object@peptides$peptide)),"\n", sep=""));
			cat (paste("number of samples : ", length(unique(object@peptides$msrun)),"\n", sep=""));
		}
)


setMethod('summary', "mcqProtValue",
		function(object, ...) {
			#nb de protéines (length(levels(protein)), nb de peptiz (length(levels(peptiz))), nb de peptides 	(length(levels(peptiz))),
			######## nb de samples (length(levels(msrun)))
			#		print (summary (object@proteins))

			cat (paste("number of proteins : ", length(rownames(object@proteins)),"\n", sep=""));
			cat (paste("number of samples : ", length(rownames(object@samples)),"\n", sep=""));
		}
)

setMethod('summary', "mcqData",
		function(object, ...) {
			#code for class_1 summary here...
			objectList <- c("samples", "groups","proteins","peptidesmh", "observedin","quantify", "quantipeptides")
			coln <- c ("type", "description", "count")
			#rown <- c (names(object))

			typelist <- c(class(object@samples), class(object@groups), class(object@proteins), class(object@peptidesmh),class(object@observedin), class(object@quantify), class(object@quantipeptides))
			desc <- c("MS samples", "Groups of MS samples","Identified proteins","Identified peptides (unique peptide-mh)", "MS/MS peptide identifications","Quantifications on groups", "peptides quantifications")
			countV <- c(length(object@samples)[[1]], length(object@groups)[[1]], length(object@proteins)[[1]], nrow(object@peptidesmh)[[1]],nrow(object@observedin)[[1]], nrow(object@quantify)[[1]], nrow(object@quantipeptides)[[1]])
			df <- data.frame(typelist, desc, countV)
			rownames (df) <- objectList
			colnames (df) <- coln
			print (df)
		}
)

setMethod('summary', "mcqMetadata",
		function(object, ...) {
			print (summary (object@metadata))
		}
)

setMethod('summary', "mcqPeptidePCA",
		function(object, ...) {
						
			cat (paste("number of XICs : ", length(object@peptides$peptiz),"\n", sep=""));
			cat (paste("number of peptiz : ", length(unique(object@peptides$peptiz)),"\n", sep=""));
			cat (paste("number of peptides : ", length(unique(object@peptides$peptide)),"\n", sep=""));
			cat (paste("number of samples : ", length(unique(object@peptides$msrun)),"\n", sep=""));
		}
)


setMethod('summary', "mcqProtList",
		function(object, ...) {
			
			cat (paste("number of proteins : ", length(object@proteins),"\n", sep=""));
		}
)