
privGetMcqPCADudiComponent <- function (object) {
	tco <- object@pca$dudi$co
	if (class(object) == "mcqProtPCA") {
		tco <- cbind.data.frame(accession = rownames(tco), tco)
	}
	else {
		tco <- cbind.data.frame(peptiz = rownames(tco), tco)
	}
	return (tco)
}

privGetMcqPCADudi <- function (object) {
	tacp <- object@pca$dudi$li
	if (is.null(object@pca$factorList)) {
		tacp <- merge(tacp, object@samples, by="row.names")
		tacp <- cbind.data.frame(sample = tacp$msrunfile, tacp)
		tacp$msrunfile <- NULL
		tacp$Row.names <- NULL
	}
	else {
		tacp <- cbind.data.frame(newcol = rownames(tacp), tacp)
		newcolname <- paste(object@pca$factorList,collapse="/")
		#print (newcolname)
		colnames(tacp)[1]<- newcolname
	}
	return (tacp)
}


privMcqPlotPCA = function (object, colors=NULL, pdf=NULL) {

	if("dudi" %in% names(object@pca)) {

	}else {
		stop(paste("no PCA made in ",class(object)," object", rep=""))
	}
	if(colors %in% names(object@metadata@metadata)) {
	}else {
		stop(paste("factor chosen for colors (", factor, ") is not described in your metadata\n", "please choose one : ", paste(colnames(object@metadata@metadata),collapse=", "), "\n", sep=""))
	}

	nbaxis <- length(object@pca$dudi$li)
	if (nbaxis < 2) {
		stop(paste("unable to plot, there is only ",nbaxis," axis",sep=""))
	}

# merge coordonnées des observations avec données traitement
	tacp <- privGetMcqPCADudi(object)
	otuname <- colnames(tacp)[1]
	labelList <- tacp[,1]
	colorList <- labelList
	displayLegend <- T
	if (is.null(object@pca$factorList)) {
		#remplir labelList avec le facteur associé à colors
		dfcolor <- merge (object@pca$dudi$li[,1:2],object@metadata@metadata, by="row.names")
		colorList <- dfcolor[,colors]
		#concatenation of factors
		#print(dfcolor)
		if (length(colnames(object@metadata@metadata)) > 1) {
			dfcolor$x <- apply( dfcolor[ , colnames(object@metadata@metadata) ] , 1 , paste , collapse = "-" )
		}
		else {
			dfcolor$x <- dfcolor[ , colnames(object@metadata@metadata) ]
		}
		labelList <- paste(labelList,dfcolor$x,sep="-")
		#print(dfcolor)
	} else {
		displayLegend <- F
	}

	sm = sum(object@pca$dudi$ei)
	pound = round((object@pca$dudi$e/sm*100),digits = 1)


	#pdf("acp_proteines_ppt.pdf")
	if (is.null(pdf)){
		par(ask=TRUE)
	}
	else{
		pdf(pdf)
	}

	plot(object@pca$dudi$co[,c("Comp1","Comp2")],xlab=paste("Axe1(",pound[1],"%)",sep=" "), ylab=paste("Axe2(",pound[2],"%)",sep=" "))

	plot(tacp[,c("Axis1","Axis2")],type="n",xlab=paste("Axe1(",pound[1],"%)",sep=" "),ylab=paste("Axe2(",pound[2],"%)",sep=" "),main="PCA")
	text(tacp[,c("Axis1","Axis2")],labels=labelList,cex=0.8, col=as.integer(colorList))
	if (displayLegend) {
		legend("topright", legend = unique(colorList), col = unique(as.integer(colorList)), pch = 15, bty = "n")
	}

	if (nbaxis > 2) {
		plot(tacp[,c("Axis1","Axis3")],type="n",xlab=paste("Axe1(",pound[1],"%)",sep=" "),ylab=paste("Axe3(",pound[3],"%)",sep=" "),main="PCA")
		text(tacp[,c("Axis1","Axis3")],labels=labelList,cex=0.8, col=as.integer(colorList))
		if (displayLegend) {
			legend("topright", legend = unique(colorList), col = unique(as.integer(colorList)), pch = 15, bty = "n")
		}

		plot(tacp[,c("Axis2","Axis3")],type="n",xlab=paste("Axe2(",pound[2],"%)",sep=" "),ylab=paste("Axe3(",pound[3],"%)",sep=" "),main="PCA")
		text(tacp[,c("Axis2","Axis3")],labels=labelList,cex=0.8, col=as.integer(colorList))
		if (displayLegend) {
			legend("topright", legend = unique(colorList), col = unique(as.integer(colorList)), pch = 15, bty = "n")
		}

		if (nbaxis > 3) {
			plot(tacp[,c("Axis3","Axis4")],type="n",xlab=paste("Axe3(",pound[3],"%)",sep=" "),ylab=paste("Axe4(",pound[4],"%)",sep=" "),main="PCA")
			text(tacp[,c("Axis3","Axis4")],labels=labelList,cex=0.8, col=as.integer(colorList))
			if (displayLegend) {
				legend("topright", legend = unique(colorList), col = unique(as.integer(colorList)), pch = 15, bty = "n")
			}

			if (nbaxis > 4) {
				plot(tacp[,c("Axis4","Axis5")],type="n",xlab=paste("Axe4(",pound[4],"%)",sep=" "),ylab=paste("Axe5(",pound[5],"%)",sep=" "),main="PCA")
				text(tacp[,c("Axis4","Axis5")],labels=labelList,cex=0.8,col=as.integer(colorList))
				if (displayLegend) {
					legend("topright", legend = unique(colorList), col = unique(as.integer(colorList)), pch = 15, bty = "n")
				}
			}
		}
	}


	barplot(pound,main="Poids des axes",ylab="%")
	#dev.off()
	if (!is.null(pdf)){
		dev.off()
	}
}