
mcqNewPeptidePCA = function (object, flist=NULL) {
	if (class(object) == "mcqProtPep") {


		############################ ACP sur protéines présentes partout (sont toutes présentes partout maintenant).

		tsamples = unique(object@peptides[,c("msrun","msrunfile")])
		rownames(tsamples) <- tsamples$msrun

		tpeptides <- object@peptides[, c("msrun","peptide","peptiz")]
		tpeptides <- drop.levels(tpeptides)

		tproteins = unique(object@proteins[,c("protein","peptide", "accession", "protein_description")])


		tacp= mcqGetCompar(object, flist)
		tacp <- na.omit(tacp)

		# cleaning dataframes after na.omit
		peptizList <- rownames(tacp)

		if (length(peptizList) < 3) {
			stop(paste("Too few peptiz (",length(peptizList),") to perform PCA", sep=""))
		}
		if (length(colnames(tacp)) < 3) {
			stop(paste("Too few dimensions (",length(peptizList),") to perform PCA", sep=""))
		}
		#print (head(peptizList))
		#print (head(tpeptides$peptiz))
		tpeptides <- tpeptides[tpeptides$peptiz %in% peptizList,]
		tpeptides <- drop.levels(tpeptides)

		msrunList <- unique(tpeptides$msrun)
		tsamples <- tsamples[tsamples$msrun %in% msrunList,]
		tsamples <- drop.levels(tsamples)
		tsamples$msrun <- NULL

		peptideList <- unique(tpeptides$peptide)
		tproteins <- tproteins[tproteins$protein %in% peptideList,]
		tproteins <- drop.levels(tproteins)



		newObject <- new ("mcqPeptidePCA", metadata = object@metadata	, peptides = tpeptides, proteins = tproteins, samples = tsamples, pca = list())
		#cat ("coucou")
		newObject@pca$dudi <- dudi.pca(t(tacp),center = T, scale = T, scannf = F, nf = 5) # on garde 5 axes
		#cat ("coucou2")
		newObject@pca$factorList <- flist
		#cat ("coucou3")

		if (is.null(object@peptides$lognorm)) {
			newObject@pca$qname <- "logarea"
		}
		else {
			newObject@pca$qname <- "lognorm"
		}

		return (newObject)

	}
	else {
		stop("input is not an mcqProtPep object")
	}
}


mcqPlotPeptidePCA = function (object, colors=NULL, pdf=NULL) {
	if (class(object) == "mcqPeptidePCA") {
		privMcqPlotPCA(object, colors, pdf)
	}
	else {
		stop("input is not an mcqPeptidePCA object")
	}
}
