

mcqDropSharedPeptides<- function (object) {
	if (class(object) == "mcqProtPep") {
		########## sélection des peptides spécifiques de protéine
		# remarque: ce sont en fait les spécifiques des sous-groupes de XtandemPipeline)


		nprot.per.pept=table(object@proteins$peptide)

		pept.spec=nprot.per.pept[nprot.per.pept==1]
		cat(paste("nb of specific peptides : ",length(pept.spec),"\n"))
		names.pept.spec=names(pept.spec)



		object@peptides <- object@peptides[object@peptides$peptide %in% names.pept.spec,]
		object@peptides <- drop.levels(object@peptides)

		tabpep <- levels(object@peptides$peptide)
		#cat(paste("nb of proteins 1 :",length(levels(object@proteins$protein)),"\n"))
		object@proteins <- object@proteins[object@proteins$peptide %in% tabpep,]
		object@proteins <- drop.levels(object@proteins)

		cat(paste("nb of specific peptiz in repeatable proteins :",length(levels(object@peptides$peptiz)),"\n"))
		cat(paste("nb of proteins :",length(levels(object@proteins$protein)),"\n"))

		return (object)

	}
	else {
		stop("input is not an mcqProtPep object")
	}
}


mcqPlotPeptidesSharedByProt<- function (object,pdf=NULL) {
	if (class(object) == "mcqProtPep") {
		########## sélection des peptides spécifiques de protéine
		# remarque: ce sont en fait les spécifiques des sous-groupes de XtandemPipeline)


		nprot.per.pept=table(object@proteins$peptide)

		# aperçu des nbres de peptides partagés par plusieurs protéines;
		if (is.null(pdf)){
			par(ask=TRUE)
		}
		else{
			pdf(pdf)
		}
		#pdf("peptides partages.pdf",title="peptides partages")
		hist(nprot.per.pept,nclass=max(nprot.per.pept))
		#dev.off()
		if (!is.null(pdf)){
			dev.off()
		}
	}
	else {
		stop("input is not an mcqProtPep object")
	}
}
